<script>
	import { onMount } from 'svelte';
	import { supabase } from '$lib/supabaseClient';
	import Navbar from '../navbar.svelte';

	/**
	 * @type {any[] | null}
	 */
	let forums;

	$: filteredForums = forums?.filter((element) => element.title.includes(searchText));

	/**
	 * @type {string}
	 */
	let title;
	/**
	 * @type {string}
	 */
	let name;

	/**
	 * @type {string}
	 */
	let detail;

	/**
	 * @type {string}
	 */
	let searchText;

	async function getForums() {
		//select * from forum
		let { data, error: err } = await supabase
			.from('forum')
			.select('*')
			.order('votes', { ascending: false });
		forums = data;
	}

	/**
	 * @param {string} id
	 * @param {number} votes
	 */
	async function voteUp(id, votes) {
		//update forum set votes = 100 where id = 23
		let { data, error } = await supabase
			.from('forum')
			.update({
				votes: votes + 1
			})
			.eq('id', id);
		getForums();
	}

	/**
	 * @param {string} id
	 * @param {number} votes
	 */
	async function voteDown(id, votes) {
		//update forum set votes = 100 where id = 23
		let { data, error } = await supabase
			.from('forum')
			.update({
				votes: votes - 1
			})
			.eq('id', id);
		getForums();
	}

	/**
	 * @param {any} id
	 */
	async function deleteForum(id) {
		let { data, error } = await supabase.from('forum').delete().eq('id', id);
		getForums();
	}

	async function postNewForum() {
		//insert into forum (title, posted_by, detail, votes)
		//values ("halo", "levi", "test halo", 0)
		let { data, error } = await supabase.from('forum').insert({
			title: title,
			posted_by: name,
			detail: detail,
			votes: 0
		});
		getForums();
	}

	onMount(function () {
		getForums();
	});
</script>
<Navbar/>
<div class="content-center">
	<div class="max-w-screen-md mx-auto p-5">
		<div class="text-center mb-6">
			<p class="mt-4 text-sm leading-7 text-gray-500 font-regular uppercase">
				Welcome
			</p>
			<h3 class="text-3xl sm:text-4xl leading-normal font-extrabold tracking-tight text-gray-900">
				Post to <span class="text-indigo-600">Forum</span>
			</h3>
		</div>
		
		<form class="w-full">
			<div class="-mx-3 mb-6">
				<div class="w-full px-3">
				<label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-first-name">
					Name
				</label>
				<input bind:value={name} class="appearance-none block w-full text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white" id="grid-first-name" type="text" placeholder="Name">
				<!-- <p class="text-red-500 text-xs italic">Please fill out this field.</p> -->
				</div>
			</div>
			<div class="-mx-3 mb-6">
				<div class="w-full px-3">
					<label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-first-name">
						Title
					</label>
					<input bind:value={title} class="appearance-none block w-full text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white" id="grid-first-name" type="text" placeholder="Title">
					<!-- <p class="text-red-500 text-xs italic">Please fill out this field.</p> -->
				</div>
			</div>
			<div class="flex flex-wrap -mx-3 mb-6">
				<div class="w-full px-3">
					<label class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2" for="grid-password">
						Detail
					</label>
					<textarea bind:value={detail} rows="6" class="appearance-none block w-full text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500"/>
				</div>
				
			
			</div>
		
		</form>
		<div class="flex justify-center w-full px-3">
			<button on:click={postNewForum} class="shadow bg-indigo-600 hover:bg-indigo-400 focus:shadow-outline focus:outline-none text-white py-2 px-6 rounded" type="submit">
				Submit
			</button>
		</div>
		
		<hr class="my-8 h-px bg-gray-200 border-0 dark:bg-gray-700">
		<!-- section forum -->
		<h3 class="mb-3 text-3xl sm:text-xl leading-normal font-bold tracking-tight text-gray-900">
			Forums
		</h3>
		<input bind:value={searchText} class="w-full p-2  border rounded" placeholder="Title to search" />
		{#if forums}
			{#each forums as forum}
				<div class="p-3 shadow-md rounded-lg my-2 px-2">
					<div class="mx-2">
						<h2 class="text-lg text-blue-600 w-5/6" >
							<a href="/forums/{forum.id}">
								{forum.title}
							</a>
						</h2>
					</div>
					<p class="mx-2">{forum.detail}</p>
					<hr class="my-4 h-px bg-gray-200 border-0 dark:bg-gray-700">
					<div class="flex"> 
						<div class="flex w-5/6">
							<p class="mx-2 text-gray-500">Posted by</p>
							<p class=" text-indigo-600" >{forum.posted_by}</p>
							<p class="mx-2 text-gray-500">&nbsp; at</p>
							<p class=" text-indigo-600" >{forum.created_at[11]}{forum.created_at[12]}:{forum.created_at[14]}{forum.created_at[15]}&nbsp;&nbsp;&nbsp;{forum.created_at[8]}{forum.created_at[9]}-{forum.created_at[5]}{forum.created_at[6]}-{forum.created_at[2]}{forum.created_at[3]}</p>
							<span class="dot mx-3 my-3 w-1 h-1 rounded-full bg-black"></span>
							<p class="mx-2 text-gray-500">{forum.votes} Votes</p>
						</div>
						<div class="flex">
							<button
							on:click={() => deleteForum(forum.id)}
							class="border border-current rounded p-1 m-1 text-sm w-6">
							<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-3 h-3">
								<path stroke-linecap="round" stroke-linejoin="round" d="M14.74 9l-.346 9m-4.788 0L9.26 9m9.968-3.21c.342.052.682.107 1.022.166m-1.022-.165L18.16 19.673a2.25 2.25 0 01-2.244 2.077H8.084a2.25 2.25 0 01-2.244-2.077L4.772 5.79m14.456 0a48.108 48.108 0 00-3.478-.397m-12 .562c.34-.059.68-.114 1.022-.165m0 0a48.11 48.11 0 013.478-.397m7.5 0v-.916c0-1.18-.91-2.164-2.09-2.201a51.964 51.964 0 00-3.32 0c-1.18.037-2.09 1.022-2.09 2.201v.916m7.5 0a48.667 48.667 0 00-7.5 0" />
							</svg>
							
						</button>
						<button
							on:click={() => voteUp(forum.id, forum.votes)}
							class="flex bg-lime-500 rounded px-2 py-1 my-1 text-sm text-white">Vote
							<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="mx-1 w-4 h-4">
								<path stroke-linecap="round" stroke-linejoin="round" d="M12 19.5v-15m0 0l-6.75 6.75M12 4.5l6.75 6.75" />
							  </svg>
							  
							
						</button>
						<button
							on:click={() => voteDown(forum.id, forum.votes)}
							class="flex bg-red-500 rounded px-2 py-1 mx-1 my-1 text-sm text-white">Vote
							<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="mx-1 w-4 h-4">
								<path stroke-linecap="round" stroke-linejoin="round" d="M19.5 13.5L12 21m0 0l-7.5-7.5M12 21V3" />
							  </svg>
						</button>
						</div>
						
					</div>
						
				</div>
			{/each}
		{/if}
	</div>
</div>
